package uam.tdaw.dinamica.controladores;

import java.util.LinkedList;

import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import uam.tdaw.dinamica.clases.Cliente;
import uam.tdaw.dinamica.clases.Destino;
import uam.tdaw.dinamica.clases.Preferencia;
import uam.tdaw.dinamica.clases.TipoViaje;
import uam.tdaw.dinamica.clases.Viaje;
import uam.tdaw.dinamica.formas.BienvenidaFrm;
import uam.tdaw.dinamica.negocio.AdministrarListas;
import uam.tdaw.dinamica.negocio.ValidarUsuario;

@Controller
public class AdministrarViajeController {

	@RequestMapping("nuevoViaje")
	public ModelAndView mostrarViajeFrm(){
		
		ModelAndView modelo = new ModelAndView("nuevo_viaje");
		
		AdministrarListas administrarListas = new AdministrarListas();
		LinkedList<Destino>listaDestinos = administrarListas.listaDestinos();
		LinkedList<TipoViaje>listaTipoViaje = administrarListas.listaTipoViaje();
		LinkedList<Preferencia>listaPreferencias = administrarListas.listaPreferencias();
		
		Viaje viaje = new Viaje();
		
		TipoViaje seleccionDefecto = listaTipoViaje.getFirst();
		listaTipoViaje.removeFirst();
		
		modelo.addObject("datosViaje", viaje);
		modelo.addObject("listaDestinosVista",listaDestinos);
		modelo.addObject("listaTipoViajeVista",listaTipoViaje);
		modelo.addObject("listaPreferenciaVista",listaPreferencias);
		modelo.addObject("seleccionDefectoVista", seleccionDefecto);
		
		modelo.addObject("bandera","REG");
		
		return modelo;
		
	}
	
	@RequestMapping(value="registrarNuevoViaje", method=RequestMethod.POST)
	public ModelAndView registrarNuevoViaje(@ModelAttribute("datosViaje")Viaje viaje, HttpSession session){
		
	
		System.out.println("Se registró el Viaje:");
		System.out.println(viaje.getDestino());
		System.out.println(viaje.getTipoViaje());
		
		for(int i=0;i<viaje.getSeleccionPreferencia().length;i++){
			System.out.println(viaje.getSeleccionPreferencia()[i]);
		}
		
		Cliente cliente = (Cliente) session.getAttribute("datosCliente");

		
		AdministrarListas administrarListas = new AdministrarListas();
		LinkedList<Viaje> listaViajes =  administrarListas.listasViajes();
		
		BienvenidaFrm bienvenidaFrm = new BienvenidaFrm();
		bienvenidaFrm.setViajes(listaViajes);
		bienvenidaFrm.setCliente(cliente);

		
		ModelAndView modelo = new ModelAndView("bienvenido","bienvenidaFrmJSP",bienvenidaFrm);
		
		return modelo;

		
	}
	
	@RequestMapping(value="actualizarViaje", method=RequestMethod.POST)
	public ModelAndView actualizarViaje(@ModelAttribute("datosViaje")Viaje viaje, HttpSession session){
		
	
		System.out.println("Se actualizó el Viaje:" + viaje.getIdViaje());
		System.out.println(viaje.getDestino());
		System.out.println(viaje.getTipoViaje());
		
		Cliente cliente = (Cliente) session.getAttribute("datosCliente");

		
		for(int i=0;i<viaje.getSeleccionPreferencia().length;i++){
			System.out.println(viaje.getSeleccionPreferencia()[i]);
		}
		
		AdministrarListas administrarListas = new AdministrarListas();
		LinkedList<Viaje> listaViajes =  administrarListas.listasViajes();
		
		BienvenidaFrm bienvenidaFrm = new BienvenidaFrm();
		bienvenidaFrm.setViajes(listaViajes);
		bienvenidaFrm.setCliente(cliente);

		
		ModelAndView modelo = new ModelAndView("bienvenido","bienvenidaFrmJSP",bienvenidaFrm);
		
		return modelo;

		
	}
	
	@RequestMapping("borrarViaje")
	public ModelAndView eliminarViaje(@RequestParam("claveViaje") int idViaje, HttpSession session){
		
		System.out.println("Se eliminará el viaje con id: " + idViaje);
		
		ValidarUsuario validarUsuario = new ValidarUsuario();
		AdministrarListas administrarListas = new AdministrarListas();
		
		
		
		Cliente cliente = (Cliente) session.getAttribute("datosCliente");
		LinkedList<Viaje>listaViajes = administrarListas.listasViajes(); 
		
		System.out.println("Está activo el cliente " + cliente.getUsuario());
		
		BienvenidaFrm bienvenidaFrm = new BienvenidaFrm();
		bienvenidaFrm.setCliente(cliente);
		bienvenidaFrm.setViajes(listaViajes);

		ModelAndView modelo = new ModelAndView("bienvenido","bienvenidaFrmJSP",bienvenidaFrm);
		
		return modelo;
	}
	
	
	@RequestMapping("editarViaje")
	public ModelAndView desplegarActualizarViaje(@RequestParam("claveViaje") int idViaje){
		
		System.out.println("Se actualizará el viaje con id: " + idViaje);
		
		ModelAndView modelo = new ModelAndView("nuevo_viaje");
		
		AdministrarListas administrarListas = new AdministrarListas();
		LinkedList<Destino>listaDestinos = administrarListas.listaDestinos();
		LinkedList<TipoViaje>listaTipoViaje = administrarListas.listaTipoViaje();
		LinkedList<Preferencia>listaPreferencias = administrarListas.listaPreferencias();
		
		Viaje viaje = new Viaje();
		viaje.setIdViaje(idViaje); //NUEVO
		
		TipoViaje seleccionDefecto = listaTipoViaje.getFirst();
		listaTipoViaje.removeFirst();
		
		modelo.addObject("datosViaje", viaje);
		modelo.addObject("listaDestinosVista",listaDestinos);
		modelo.addObject("listaTipoViajeVista",listaTipoViaje);
		modelo.addObject("listaPreferenciaVista",listaPreferencias);
		modelo.addObject("seleccionDefectoVista", seleccionDefecto);
		modelo.addObject("bandera","ACT");
		
		return modelo;

		
	}
	
}
