package uam.tdaw.dinamica.controladores;


import java.util.LinkedList;

import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import uam.tdaw.dinamica.clases.Cliente;
import uam.tdaw.dinamica.clases.Usuario;
import uam.tdaw.dinamica.clases.Viaje;
import uam.tdaw.dinamica.formas.BienvenidaFrm;
import uam.tdaw.dinamica.negocio.AdministrarListas;
import uam.tdaw.dinamica.negocio.ValidarUsuario;

@Controller
public class ValidacionController {

	@RequestMapping("/")
	public ModelAndView mostrarUsuarioFrm(){
		
		ModelAndView modelo = new ModelAndView("login");
		Usuario usuario = new Usuario();
		modelo.addObject("usuarioFrm", usuario);
		
		return modelo;
		
	}
	
	@RequestMapping(value="validarUsuario", method=RequestMethod.POST)
	public ModelAndView validarUsuario(@ModelAttribute("usuarioFrm")Usuario usuario, HttpSession session){
		
		ValidarUsuario validarUsuario = new ValidarUsuario();
		AdministrarListas administrarListas = new AdministrarListas();
		
		Cliente cliente = validarUsuario.validarUsuario(usuario);
		
		session.setAttribute("datosCliente", cliente);
		
		LinkedList<Viaje>listaViajes = administrarListas.listasViajes(); 
		
		System.out.println("Entró el cliente " + cliente.getUsuario());
		
		BienvenidaFrm bienvenidaFrm = new BienvenidaFrm();
		bienvenidaFrm.setCliente(cliente);
		bienvenidaFrm.setViajes(listaViajes);

		ModelAndView modelo = new ModelAndView("bienvenido","bienvenidaFrmJSP",bienvenidaFrm);
		
		return modelo;
	}
	
	@RequestMapping("logout")
	public ModelAndView salirAplicacion(HttpSession session){
		
		ModelAndView modelo = new ModelAndView("login");
		Usuario usuario = new Usuario();
		modelo.addObject("usuarioFrm", usuario);
		session.removeAttribute("datosCliente");
		System.out.println("Saliendo y Liberando al cliente de la sesión");
		
		return modelo;
		
	}
	
}
